#INCLUDE ../EPROM.H

#IFDEF P_PPC;
   #IF EPROM 
      SC=$7000,CODE=$0,VAR=$0;
   #ELSE
      S=7000;
   #FIN;
#FIN; 

#IFDEF P_68K;
   #IF EPROM
      SC=$5000,CODE=$0,VAR=$0;
   #ELSE
      S=5000;
   #FIN;
#FIN;  

#DEFINE IEP_SOCKET = 1 ; ! 0=IRT/esd-Socket, 1=IEP-Socket  
#DEFINE BLOCKSIZE = 2048 ;


MAXERR=10; MODE=NOLSTOP,DEBUG; /* +T*/ /*+M */ ! Enable: remove  gap

MODULE HTTPLIB ;

PROBLEM ;
   /*                                               */ 
   /* UEBERGABE STRUCTUREN AN DAS TCP               */
   /*                                               */ ;
/* */
#DEFINE  THIS_IS_HTTPLIB = 1 ;
#INCLUDE HTTPLIB.h ; /* */

   TYPE TCP_STAT STRUCT (/  DEST_ADDR    BIT(32)     ,
                            SOURCE_PORT  FIXED(15)   ,
                            DEST_PORT    FIXED(15)   ,
                            TIME_OUT     FIXED(31)   ,
                            F_NAME       CHAR(32)    ,
                            SOURCE_ADDR  BIT(32)     , 
                            PUSH_FLAG    FIXED(15)   ,
                            URG_FLAG     FIXED(15)   ,
                            SND_WND      FIXED(31)   ,
                            RCV_WND      FIXED(31)   ,   
                            T_STATE      FIXED(15)
                        /);    

 

   DCL IEP_MAX_PORT INV FIXED INIT( 64 ) ;

   DCL IEP_CONN( IEP_MAX_PORT ) TCP_SOCKET ;

   DCL http_demon_zahl FIXED INIT(0) ; /* Erzeugt den Filenamen von 0-255 */

! For self-identification of this server:
   DCL ServerName        INV CHAR(32) INIT('Server: RTOS-UH-HTTP_Demon/1.1');



  SPC NETSTERR ENTRY( NETSTATUS FIXED(15),AUSGABE BIT(1),TY DATION OUT ALPHIC IDENT )
              RETURNS(FIXED(15));


! *******************************************************************
! *  DATE_EQ compares the incoming extracted data with the          *
! *  given TOUCH_DATA. Result is true if both are equal             *
!                                                                   *
!    The proc needs the static tables MSTR1 and MSTR2 as follows:   *
!    DCL MSTR1 INV CHAR(36) INIT('JANFEBMARAPRMAY ......'           *
!    DCL MSTR2 INV CHAR(36) INIT('JanFebMarAprMay ......'           *
! *******************************************************************

DATE_EQU: PROC( (BUFFER,TOUCH_DATA) CHAR(50), 
           loglink DATION OUT ALPHIC IDENT
          ) 
          RETURNS( BIT(1) ) GLOBAL ;

  DCL BUFFER_KONV          CHAR(50);

  DCL POS                  FIXED(15);

  DCL MINUTE                CHAR(2); 
  DCL STUNDE                CHAR(2); 
  DCL TAG                   CHAR(2); 
  DCL MONAT                 CHAR(3);
  DCL MONAT_STR2            CHAR(2);
  DCL JAHR                  CHAR(4);

  DCL TOUCH_MINUTE          CHAR(2);
  DCL TOUCH_STUNDE          CHAR(2);
  DCL TOUCH_TAG             CHAR(2);
  DCL TOUCH_MONAT           CHAR(2);
  DCL TOUCH_JAHR            CHAR(4);

  DCL DATEEQ                BIT(1);

  BUFFER_KONV=' ';
  FOR I TO LEN(BUFFER) REPEAT
    CASE BUFFER.CHAR(I)
      ALT (':') BUFFER_KONV.CHAR(I)=':';
      ALT ('0':'9') BUFFER_KONV.CHAR(I)='N';
      ALT ('A':'Z','a':'z') BUFFER_KONV.CHAR(I)='A';
    FIN;
  END;

  ! ... Isolate time of the day .........................................
  POS  = INSTR(BUFFER_KONV,1,LEN(BUFFER_KONV),'NN:NN:NN',1,8);
  IF POS NE 0 THEN
    STUNDE = MID(BUFFER,POS,POS+1);
    MINUTE = MID(BUFFER,POS+3,POS+4);
  FIN; /* IF POSTION NE 0 THEN */

  ! ... Try several alternative ways to isolate the date ................

  ! TAG,MONAT UND JAHR HERAUSSCHNEIDEN 1.ALTERNATIVE !
  ! DIESE ALTERNATIVE IST ENTSTANDEN, WEIL ES NETSCAPE NICHT FUER NOETIG HAELT
  ! DIE KOMPLETTE JAHRESANGABE ZU SENDEN, SONDERN NUR DIE LETZTEN BEIDEN ZIFFERN 
  ! DES JAHRES. SPRICH' ANSTELLE VON 1998 SENDET NETSCAPE 98 !! SUPER !

  POS  = INSTR(BUFFER_KONV,1,LEN(BUFFER_KONV),' NN AAA NN ',1,11);
  IF POS NE 0 THEN
    POS = POS +1;
    TAG   = MID(BUFFER,POS,POS+1);
    MONAT = MID(BUFFER,POS+3,POS+5);
    JAHR  ='19';
    JAHR.CHAR(3)  = MID(BUFFER,POS+7,POS+7);
    JAHR.CHAR(4)  = MID(BUFFER,POS+8,POS+8);
    IF TOFIXED(JAHR.CHAR(3)) LT 5 THEN
      JAHR.CHAR(1) = '2'; JAHR.CHAR(2)= '0';
    FIN;

  ELSE      ! If the 1st did not work 

  POS  = INSTR(BUFFER_KONV,1,LEN(BUFFER_KONV),' NN AAA NNNN ',1,13);
  IF POS NE 0 THEN
    POS = POS +1;
    TAG   = MID(BUFFER,POS,POS+1);
    MONAT = MID(BUFFER,POS+3,POS+5);
    JAHR  = MID(BUFFER,POS+7,POS+10);
  FIN; /* IF POSTION NE 0 THEN */

  FIN;

  POS=INSTR(MSTR1,1,36,MONAT,1,3);
  IF POS LE 0 THEN
    POS=INSTR(MSTR2,1,36,MONAT,1,3);
  FIN;

  CONVERT ((POS+2)//3) TO MONAT_STR2 BY F(2);

  IF MONAT_STR2.CHAR(1) == ' ' THEN MONAT_STR2.CHAR(1)='0'; FIN;

  TOUCH_STUNDE:=MID(TOUCH_DATA,1,2);
  TOUCH_MINUTE:=MID(TOUCH_DATA,4,5);
  TOUCH_TAG   :=MID(TOUCH_DATA,11,12);
  TOUCH_MONAT :=MID(TOUCH_DATA,14,15);
  TOUCH_JAHR  :=MID(TOUCH_DATA,17,20);

  #IF MAXILOG 
   PUT 'S: (DTCMP) Client-data min:',MINUTE,' hour:',STUNDE,' day:',TAG,' month:',
      MONAT_STR2,' year:',JAHR 
      TO loglink BY A,A(2),A,A(2),A,A(2),A,A(3),A,A(LEN(JAHR));

   PUT 'S: (DTCMP) Server-data min:',TOUCH_MINUTE,' hour:',TOUCH_STUNDE,
      ' day:', TOUCH_TAG,' month:',TOUCH_MONAT,' year:',
      TOUCH_JAHR 
      TO loglink BY A,A(2),A,A(2),A,A(2),A,A(3),A,A(LEN(TOUCH_JAHR));
  #FIN; 


  ! HIER KOMMT JETZT DER VERGLEICH ZWISCHEN DEM DATUM, DAS UNS DER CLIENT IM 
  ! IF-MODIFIED-SINCE GESENDET HAT, UND DEM DATUM, DAS UNS DAS FILESYSTEM 
  ! LIEFERT. DIESES DATUM ZEIGT AN, WANN DIE DATEI ZUM LETZEN MAL GEAENDERT
  ! WORDEN IST. WENN DAS DATUM NICHT UNTERSCHIEDLICH IST, WIRD IN DIE VARIABLE
  ! METHOD_OR_ERROR EIN "NOT-MODIFIED" EINGETRAGEN. DIES HAT ZUR FOLGE, DAS DER
  ! HEADER DANN EIN NOT-MODIFIEDHEADER AN DEN CLIENT SENDET UND DIE DATEI DANN
  ! NICHT MEHR VON SENDFILE GESENDET WIRD. WENN DAS DATUM UNTERSCHIEDLICH IST,
  ! DANN WIRD NICHTS IN METHOD_OR_ERROR EINGETRAGEN, UND DIE DATEI WIRD DANN 
  ! EINFACH GESENDET, EGAL OB SIE AELTER ODER JUENGER IST !!!   


  DATEEQ =      (TOUCH_MINUTE == MINUTE)
      AND   (TOUCH_STUNDE == STUNDE)
      AND   (TOUCH_TAG    == TAG)
      AND   (TOUCH_MONAT  == MONAT_STR2) 
      AND   (TOUCH_JAHR   == JAHR);


  #IF MAXILOG
  IF DATEEQ THEN
    WRITE 'S: (DTCMP) Result: Not modified' TO loglink;
  ELSE  
    WRITE 'S: (DTCMP) Result: Modified' TO loglink;
  FIN;
  #FIN

  RETURN(DATEEQ);

END; /* P DATE_EQU */


! *******************************************************************
! * INCLUDE-FILE : DATUM.INC                                        *
! *-----------------------------------------------------------------*
! * ENTHALTENE PROZEDUREN : SCHALTJAHR                              *
! *                         TAGESNUMMER                             *
! *                         WOCHENTAG                               *
! *-----------------------------------------------------------------*
! * ERKLAERUNG : DIESE PROZEDUREN WERDEN FUER DIE WOCHENTAGS-       *
! *              BERECHNUNG BENTIGT (MONTAG,DIENTSTAG,...).        *
! *              MAN KANN ABER NOCH VIEL MEHR MIT IHNEN BERECHEN !  *
! *              SIEHE DAZU C'T,1997,HEFT 15,SEITE 312,             *
! *              'IMMER WIEDER SONNTAG, ALGORITHMEN ZUR DATUMS-     *
! *              BERECHNUNG')                                       *
! *-----------------------------------------------------------------*
! * AUTOR            : LARS SCHREINER                               *
! *-----------------------------------------------------------------*
! * ERSTELLT         : 15.05.1998                                   *
! * LETZTE AENDERUNG : 15.05.1998                                   *
! *******************************************************************

! *******************************************************************
! *    SCHALTJAHR BERECHNET OB DAS ANGEGEBENE JAHR EINSCHALTJAHR    *
! *    IST ODER NICHT ! (C'T,1997,HEFT 15,SEITE 312,'IMMER WIEDER   *
! *                     SONNTAG, ALGORITHMEN ZUR DATUMSBERECHNUNG') *
! *******************************************************************

SCHALTJAHR:PROC(JAHR FIXED(15)) RETURNS(FIXED(15)) GLOBAL;

   IF ( ((JAHR REM 4) EQ 0) AND ((JAHR REM 100) NE 0) ) 
      OR ((JAHR REM 400) EQ 0) THEN
      RETURN(1);
   ELSE
      RETURN(0);
   FIN;
END; /* SCHALTJAHR */


! *******************************************************************
! *         TAGESNUMMER ORDNET JEDEM TAG EINE NUMMER ZU !           *
! * (C'T,1997,HEFT 15,SEITE 312,'IMMER WIEDER SONNTAG, ALGORITHMEN  *
! *                     ZUR DATUMSBERECHNUNG')                      *
! *******************************************************************

TAGESNUMMER:PROC( (JAHR,MONAT,TAG) FIXED(15) ) RETURNS(FIXED(15)) GLOBAL ;

DCL (D,E)      FIXED(15)   INIT(0,0);   
   
   D = ENTIER((MONAT+10)/13);
   E = ENTIER(TAG+(611*(MONAT+2))/20 - 2*D - 91);
  
   RETURN(E+SCHALTJAHR(JAHR)*D);
END; /* TAGESNUMMER:PROC */

! *******************************************************************
! *    WOCHENTAG ORDNET JEDER TAGESNUMMER EINE NAMENSNUMMER ZU !    *
! *        Z.B.: SONNTAG = 0, MONTAG = 1,...,SAMSTAG = 6 !          *
! * (C'T,1997,HEFT 15,SEITE 312,'IMMER WIEDER SONNTAG, ALGORITHMEN  *
! *                     ZUR DATUMSBERECHNUNG')                      *
! *******************************************************************

WOCHENTAG:PROC( (JAHR,TAGNUMMER) FIXED(15)) RETURNS(FIXED(15)) GLOBAL;

DCL (J,C)     FIXED(15)  INIT(0,0);
   
   J =  (JAHR-1) REM 100 ;
   C = ENTIER( (JAHR-1) / 100 );
   RETURN( (28+J+TAGNUMMER+ENTIER(J/4)+ENTIER(C/4)+5*C) REM 7 );
END; /* WOCHENTAG:PROC */

! *******************************************************************
! *           TAGNAME ORDNET JEDEM TAG EINEN NAMEN ZU !             *
! *******************************************************************

TAGNAME:PROC( (TAG,MONAT,JAHR) FIXED(15)) RETURNS(CHAR(10)) GLOBAL;

  RETURN(DAYNAME(WOCHENTAG(JAHR,TAGESNUMMER(JAHR,MONAT,TAG))));
       
END; /* TAGNAME:PROC */

! *******************************************************************
! *           MONATNAME ORDNET JEDEM TAG EINEN NAMEN ZU !           *
! *******************************************************************

! MONATNAME:PROC( MONAT FIXED(15)) RETURNS(CHAR(3));
!
! This function has been replaced by an array of constants


! *******************************************************************
! * FileErr gibt zu dem auftretenden Fehler des Filemanagers        *
! * die Fehlermeldung im Klartext aus.                              *
! *******************************************************************

FileErr:PROC /*+G*/ (ERROR FIXED (15),TY DATION OUT ALPHIC IDENT) GLOBAL ;

 DCL VOIDPTR REF INV STRUCT[];
 DCL C255PTR REF INV CHAR(255);
 DCL TXLEN FIXED;

  WRITE ''\0D0A\'Filesystem Error :' TO TY;

  VOIDPTR=NIL;

  CASE ERROR
    ALT (1)  VOIDPTR = 'END-OF-FILE.';
    ALT (2)  VOIDPTR = 'READ ERROR.';
    ALT (7)  VOIDPTR = 'TIME-OUT.';
    ALT (8)  VOIDPTR = '# of SKIPS negative.';
    ALT (9)  VOIDPTR = '# of X or PAGE negative.';
    ALT (11) VOIDPTR = 'Data type and FORMAT do not match.';
    ALT (14) VOIDPTR = 'Device not suited for this operation.';
    ALT (15) VOIDPTR = 'Path-list error.';
    ALT (33) VOIDPTR = 'Data address error.';
    ALT (34) VOIDPTR = 'Track 00 not found.';
    ALT (35) VOIDPTR = 'Aborted command error.';       
    ALT (36) VOIDPTR = 'Controller Fault.';
    ALT (37) VOIDPTR = 'ID-field not found.';
    ALT (38) VOIDPTR = 'CRC error in ID or Data.';
    ALT (39) VOIDPTR = 'Uncorrectable data error.';
    ALT (40) VOIDPTR = 'Bad Block Found.';
    ALT (41) VOIDPTR = 'Drive not ready.';
    ALT (42) VOIDPTR = 'Device write-protected.';
    ALT (43) VOIDPTR = 'Disk changed.';
    ALT (44) VOIDPTR = 'Drive not present.';
    ALT (45) VOIDPTR = 'Disk format unknown.';
    ALT (46) VOIDPTR = 'Directory active.';
    ALT (47) VOIDPTR = 'Path list error.';
    ALT (48) VOIDPTR = 'Directory in system.';
    ALT (49) VOIDPTR = 'Directory not found.';
    ALT (50) VOIDPTR = 'File not found.';
    ALT (51) VOIDPTR = 'Disk full error.';
    ALT (52) VOIDPTR = 'Filesystem not consistent.';
    ALT (53) VOIDPTR = 'Drive busy (raw mode).';
    ALT (54) VOIDPTR = 'File in system.';
    ALT (55) VOIDPTR = 'Root directory or disk full.';
    ALT (56) VOIDPTR = 'No DOS format.';
    ALT (57) VOIDPTR = 'Fatal error in block 0.'; 
    ALT (58) VOIDPTR = 'Exclusive open (no access right).';
    OUT      VOIDPTR = 'No info available for this error.';
  FIN;

  IF VOIDPTR ISNT NIL THEN
    C255PTR = VOIDPTR;
    TXLEN = INSTR(C255PTR,1,255,'.',1,1);
    PUT C255PTR TO TY BY A(TXLEN),SKIP;
    AFTER 1 SEC RESUME;    
  FIN;

END; /* FileErr */

! *******************************************************************
! * FILELENGTH ERMITTELT DIE LAENGE DES ANGEGEBENEN FILES UND GIBT  *
! *                           SIE ZURCK !                          *
! *      DIESE PROZEDUR FUNKTIONIERT FUER ALLE DATEIENTYPEN !       *
! *    !! DIESES INCLUDE-FILE IST NUR FUER DAS MODULE SYSTEM !!     *
! *!! FUER DEN HTTP-DAEMON IST DAS INCLUDE-FILE FILELENG.INC  !!    *
! *-----------------------------------------------------------------*
! * BENOETIGTE PROGRAMME / INCLUDE-FILES : FILEERR.INC              *
! *                                        NETLNK.SR                *
! *                                                                 *
! *                                                                 *
! *                                                                 *
! *-----------------------------------------------------------------*
! * ERSTELLT         : 05.05.1998                                   *
! * LETZTE AENDERUNG : 20.04.1999                                   *
! *******************************************************************
 FILELENGTH: PROC( FILENAME     CHAR(255) IDENT,
                   CONTENT_TYPE   CHAR(255) IDENT,
                   METHOD_OR_ERROR  CHAR(255) IDENT,
                   stdout       DATION INOUT ALPHIC IDENT,
                   stderr       DATION INOUT ALPHIC IDENT,
                   file2        DATION INOUT ALPHIC IDENT,
                   loglink        DATION   OUT ALPHIC IDENT
                 ) RETURNS(FIXED(31)) GLOBAL;
    
    DCL filestate            FIXED(15)    INIT(0);
    DCL LAENGE               FIXED(31)    INIT(0);
     
    OPEN file2 BY IDF(FILENAME),OLD;
    filestate:=ST(file2);
    IF (filestate NE 0) THEN
       #IF MINILOG+MAXILOG 
           PUT 'Ax: FILELENGTH : unable to open file ',FILENAME
                TO loglink BY A,A(LEN(FILENAME));
       #FIN; 
       PUT 'HTTP-User: FILELENGTH : KONNTE DATEI ',FILENAME,
           ' NICHT OEFFNEN !' TO 
           stderr BY A,A(LEN(FILENAME)),A,SKIP;
    FIN;    
    
    IF (filestate == 0) THEN

       APPEND(file2);
       SAVEP(file2,LAENGE);  

       CLOSE file2;
       filestate:=ST(file2);
       IF (filestate NE 0) THEN
          PUT 'FILELENGTH : KONNTE DATEI ',FILENAME,
              ' NICHT SCHLIESSEN !' TO 
              stdout BY A,A(LEN(FILENAME)),A,SKIP;
          PUT 'SYSTEM- FEHLER : ',filestate TO stdout BY SKIP,A,F(3);
          FileErr( filestate, stdout );
          #IF MAXILOG+MINILOG 
              PUT 'Ax: FILELENGTH : unable to close file ',FILENAME
                  TO loglink  BY A,A(LEN(FILENAME));
              PUT 'Ax: File-error #',filestate TO loglink BY A,F(3);
              FileErr(filestate,loglink);
          #FIN; 
       FIN;   
    ELSE 
     /* filestate != 0 */
       PUT 'FILELENGTH : KONNTE DATEI ',FILENAME,' NICHT OEFFNEN !'
           TO stdout BY A,A(LEN(FILENAME)),A,SKIP;
       PUT 'SYSTEM- FEHLER : ',filestate TO stdout BY SKIP,A,F(3);
       FileErr( filestate, stdout );
       #IF MAXILOG+MINILOG 
           PUT 'Ax: FILELENGTH : Unable to open file ',FILENAME
               TO loglink BY A,A(LEN(FILENAME));
           PUT 'Ax: File-error #',filestate TO loglink BY A,F(3);
           FileErr(filestate,loglink);
       #FIN; 
    FIN; /* IF (FILESTATE == 0) THEN */

    #IF MAXILOG 
        PUT 'Ax: FILELENG : FILENAME : ',FILENAME TO 
            loglink BY A,A(LEN(FILENAME));
        PUT 'Ax: FILESIZE            : ',LAENGE TO 
            loglink BY A,F(10);
    #FIN; 

    RETURN(LAENGE);
 END; /*FILELENGTH*/

! *******************************************************************
! * In dieser Includedatei sind die Prozeduren zusammengefasst, die *
! * zum Erstellen eines HTTP-Headers gehoren.                       *
! *-----------------------------------------------------------------*
! * Autor :  W. Gerth  April 20, 2000 (Vorlage L. Schreiner)        *
! *******************************************************************
! *LAMO-EXP creates strings for procs LAST_MODIFIED and EXPIRES     *
! *******************************************************************

LAMO_EXP: PROC(DATA CHAR(100),LASTMODDATE CHAR(10),LASTMODTIME CHAR(8))
                   RETURNS(CHAR(100));

    DCL Y                     CHAR(100);    ! internal buffer
    DCL TAG_FIXED15           FIXED(15);
    DCL MONAT_FIXED15         FIXED(15);
    DCL JAHR_FIXED15          FIXED(15);

!   DATA='Last-Modified:'; or DATA='Expires:';  -> see caller

    CONVERT TAG_FIXED15,MONAT_FIXED15,JAHR_FIXED15
             FROM LASTMODDATE BY F(2),X,F(2),X,F(4);

    Y:=TAGNAME(TAG_FIXED15,MONAT_FIXED15,JAHR_FIXED15);
    DATA=KON(DATA,1,LEN(DATA)+1,Y,1,LEN(Y));     ! ..: day
    DATA=KON(DATA,1,LEN(DATA),', ',1,2);         ! ..: day, 
    DATA=KON(DATA,1,LEN(DATA)+1,LASTMODDATE,1,2);! ..: day, xx  
    DATA.CHAR(LEN(DATA)+1)='-';                  ! ..: day, xx-
    Y:=MONATNAME(MONAT_FIXED15);
    DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));       ! ..: day, xx-month  
    DATA=KON(DATA,1,LEN(DATA),'-',1,1);          ! ... day, xx-month- 
    DATA=KON(DATA,1,LEN(DATA),LASTMODDATE,7,10); ! ... day, xx-month-year  
    DATA:=KON(DATA,1,LEN(DATA)+1,LASTMODTIME,1,8); ! ... year time  
    DATA=KON(DATA,1,LEN(DATA)+1,'GMT'\0D0A\'',1,5);! ... year time GMT  

     ! VORHER GMT+2. ABER DAMIT LAESST SICH DER VERGLEICH BEI 
     ! IF-MODIFIED-SINCE NICHT DURCHFUEHREN,
     ! DA DORT IMMER DIE ZEIT IN GMT ANGEGEBEN WIRD !

    RETURN(DATA);

END; /* LAMO_EXP */ 

! *******************************************************************
! *    HEADER FGT IN DEN HTTP-KOPF DIE LAENGE DES VOM CLIENT ZU    *
! *  ERWARTENDEN DOKUMENTS EIN UND SENDET DIESEN KOPF ZUM CLIENT !  *
! *                                                                 *
! *                                                                 *
! *-----------------------------------------------------------------*
! * AUTOR : LARS SCHREINER/ all new W. Gerth                        *
! *-----------------------------------------------------------------*
! * ERSTELLT         : 29.04.1998                                   *
! * LETZTE AENDERUNG : 20.04.2000                                   *
! *******************************************************************
 
HEADER: PROC /*+G*/
        ( CHILD FIXED,
              LAENGESTR CHAR(12) IDENT,
              CONTENTTYPE CHAR(255),
              METHOD_OR_ERROR FIXED IDENT,
              LASTMODDATE CHAR(10),
              LASTMODTIME CHAR(8),
              stderr DATION OUT ALPHIC IDENT,
              loglink DATION OUT ALPHIC IDENT
            ) GLOBAL;

   DCL (DATA,Y)              CHAR(255); 
   DCL NETERROR              FIXED(15)    INIT(0);
   DCL SUCHSTR               CHAR(50);
   DCL POS                   FIXED(15);
   DCL NETST                 FIXED(15);
   DCL LEN_MOR               FIXED(15);
   DCL NOT_MODIF             BIT(1);
   DCL TLEN                  FIXED(15);


   NOT_MODIF=FALSE;                           ! Asume 'modified' 

   DATA = ' ' ;
   CASE (METHOD_OR_ERROR REM 1000)

    ALT(M_BADRQ)            DATA:='HTTP/1.0 400';
    ALT(M_FNF)              DATA:='HTTP/1.0 404';
    ALT(M_GET_FNM)          DATA:='HTTP/1.0 304';
                    NOT_MODIF=TRUE;
    ALT(M_GET_N,M_GET_FMO,M_GET_AP,M_POST_AP)
                    DATA:='HTTP/1.0 200';

   FIN;

   DATA=KON(DATA,1,LEN(DATA),' Document follows'\0D0A\'MIME-Version: 1.0'\0D0A\'',1,38);
   DATA=KON(DATA,1,LEN(DATA),ServerName,1,LEN(ServerName));
   DATA=KON(DATA,1,LEN(DATA),''\0D0A\'',1,2);

   IF NOT NOT_MODIF THEN                      ! If a modified content_

      DATA=KON(DATA,1,LEN(DATA),'Content-Type: ',1,14); 
      DATA=KON(DATA,1,LEN(DATA),CONTENTTYPE,1,LEN(CONTENTTYPE));
      DATA=KON(DATA,1,LEN(DATA),''\0D0A\'Content-Length: ',1,18);
      DATA=KON(DATA,1,LEN(DATA),LAENGESTR,BEG(LAENGESTR),LEN(LAENGESTR));
      TLEN=LEN(DATA);
      DATA.CHAR(TLEN+1)=''\0D\'';
      DATA.CHAR(TLEN+2)=''\0A\'';

   FIN;    

   IF LEN(LASTMODDATE) == 0 AND LEN(LASTMODTIME) == 0 THEN  ! If both not set
     LASTMODDATE:=DATE;  
     CONVERT NOW TO LASTMODTIME BY T(8);
     Y:=LAMO_EXP('Last-Modified:',LASTMODDATE,LASTMODTIME);
     DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));  
     Y:=LAMO_EXP('Expires:',LASTMODDATE,LASTMODTIME);
     DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));  
   ELSE
     IF NOT NOT_MODIF THEN               ! If not special 3xx xfer
       Y:=LAMO_EXP('Last-Modified:',LASTMODDATE,LASTMODTIME);
       DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));
     FIN; ! If NOT NOT_MODIF   
   FIN; /* IF DATUM EQ '' AND ZEIT EQ '' THEN */       
   
  ! *******************************************************************
  ! *  Set a final CR+LF at the end of the file and transmit data     *
  ! *******************************************************************
   DATA=KON(DATA,1,LEN(DATA),''\0D0A\'',1,2); ! Separator to the HTML-Text
   
   #IF MAXILOG 
    PUT 'S: (HEADER) sending ',LEN(DATA),' bytes:'
        TO loglink BY A,F(3),A;
    PUT DATA TO loglink BY A(LEN(DATA));
   #FIN; 
   NETST=NETLINK(CHILD,DATA.CHAR(1),LEN(DATA),SO_WRITE,FLG_PUSH+FLG_WAIT,stderr,loglink);
   NETERROR=NETSTERR(NETST,'1'B,stderr);
   IF NETERROR NE 0 AND NETERROR NE 3 THEN
     WRITE 'HTTP-USER: NETERROR in PROC HEADER !'\0D0A\'' TO stderr;
     #IF MAXILOG+MINILOG
      WRITE 'S: (HEADER): NET-ERROR!' TO loglink;
      NETERROR=NETSTERR(NETST,'1'B,loglink);
     #FIN;
           
   FIN; /* IF NETERROR NE 0 THEN */
 
END; /* HEADER : PROC */
 

! *********************************************************************
!      This procedure removes the addressed list from memory 
! *********************************************************************

RM_LIST: PROC /*+G*/ (ROOT REF LISTE IDENT,loglink DATION OUT ALPHIC IDENT) GLOBAL;

   DCL (Tofree,Nxtblock) REF LISTE;

   #IF MAXILOG;
    DCL RMCOUNT FIXED(31) INIT (1(31));
    DCL LENBUF  FIXED(31);

    LENBUF = ROOT.Indexw;
   #FIN;

   IF ROOT IS NIL THEN RETURN; FIN;

   Tofree = ROOT.Next;

   WHILE Tofree ISNT NIL REPEAT
    Nxtblock = Tofree.Next;
    FREE(Tofree);
    #IF MAXILOG;
     RMCOUNT=RMCOUNT+1(31);
    #FIN;
    Tofree = Nxtblock;
   END;

   FREE(ROOT); ROOT = NIL;

   #IF MAXILOG;
    PUT 'S or Ax: (RM_LIST)',LENBUF,' bytes in ',RMCOUNT, ' blocks removed' 
     TO loglink BY A,F(8),A,F(4),A;
   #FIN;

   RETURN;
END;  ! RM_LIST


! *********************************************************************
!      This procedure writes byte-data into a chained memory list
! *********************************************************************

WRITE_TO_LIST: PROC /*+G*/ ( ROOT REF LISTE IDENT,
                             Txt REF INV STRUCT[],
                             Txtlen FIXED(31),
                             loglink DATION OUT ALPHIC IDENT
                           ) GLOBAL;

 DCL IndexPTR REF FIXED(31);             ! For fast access to index
 DCL (Actblock,Newblock) REF LISTE;      ! For fast access to blocks
 DCL Blockno FIXED(31);                  ! Current block number
 DCL Bytes_to_go FIXED(31);              ! to be done in one block
 DCL Locindex FIXED(31);                 ! Index inside actual block
 DCL Space FIXED(31);                    ! Space inside actual block

 DCL (C1PTRS) REF INV CHAR(1);        ! For case of char(1) xfer
 DCL (C1PTRT) REF     CHAR(1);        ! For case of char(1) xfer
 DCL (C16PTRS) REF INV CHAR(16);     ! For case of char(16) xfer
 DCL (C16PTRT) REF     CHAR(16);     ! For case of char(16) xfer
 DCL (C32PTRS) REF INV CHAR(32);     ! For case of char(32) xfer
 DCL (C32PTRT) REF     CHAR(32);     ! For case of char(32) xfer
 DCL (C48PTRS) REF INV CHAR(48);     ! For case of char(48) xfer
 DCL (C48PTRT) REF     CHAR(48);     ! For case of char(48) xfer
 DCL (C64PTRS) REF INV CHAR(64);     ! For case of char(64) xfer
 DCL (C64PTRT) REF     CHAR(64);     ! For case of char(64) xfer
 DCL (C96PTRS) REF INV CHAR(96);     ! For case of char(96) xfer
 DCL (C96PTRT) REF     CHAR(96);     ! For case of char(96) xfer
 DCL (C128PTRS) REF INV CHAR(128);  ! For case of char(128) xfer
 DCL (C128PTRT) REF     CHAR(128);  ! For case of char(128) xfer
 DCL (C160PTRS) REF INV CHAR(160);  ! For case of char(160) xfer
 DCL (C160PTRT) REF     CHAR(160);  ! For case of char(160) xfer
 DCL (C192PTRS) REF INV CHAR(192);  ! For case of char(192) xfer
 DCL (C192PTRT) REF     CHAR(192);  ! For case of char(192) xfer

 DCL Target REF STRUCT[];                ! where to write

! .... First we have to check for a valid root-pointer .................

 IF ROOT IS NIL THEN
   ROOT = MALLOC(SIZEOF(ROOT),1);
   IF ROOT IS NIL THEN                   ! Did MALLOC succeed?
     #IF MAXILOG+MINILOG;
       WRITE 'S or Ax: Malloc failed, insuff. memory' TO loglink; 
     #FIN;
     RETURN;                             ! Very bad: ignore request
   FIN;
   ROOT.Next = NIL; ROOT.Pred = NIL;     ! Init the links
   ROOT.Last = ROOT;                     ! Last block is root itself
   ROOT.Indexw  = 0(31) ;                ! Reset because this is a virgin
   ROOT.datptr  = NIL   ;
   ROOT.datlen  = 0(31) ;
   ROOT.headlen = 0(31) ;
 FIN;

 IndexPTR = ROOT.Indexw;                 ! The writer index (fast access)

! .... Determine the block to write to ................................

 Actblock = ROOT.Last;
 Locindex=TOFIXED(TOBIT(IndexPTR FIT 1(15)) AND TOBIT(BLOCKSIZE -1));  ! extract
 CONT IndexPTR = IndexPTR+Txtlen;

! .... Deposit the incoming text inside the list ......................
! .... Due to the fact, that the string-move generated by the compiler
! .... is much faster than any byte by byte copy, we use variable-length
! .... pointers. If the "BY TYPE" way is accepted: rearrange this!

 WHILE Txtlen > 0 OR Locindex == BLOCKSIZE REPEAT ! As long as there are data 
   Space = BLOCKSIZE-Locindex;
   IF Space LE 0(31) THEN                ! New block required ?
      Newblock = MALLOC(SIZEOF(ROOT),1); ! Grab a new block
      IF Newblock IS NIL THEN
        #IF MAXILOG+MINILOG;
          WRITE 'S or Ax: Malloc failed, insuff. memory' TO loglink; 
        #FIN;
        CONT IndexPTR = IndexPTR-Txtlen; ! Recorrect fill state
        RETURN;                          ! Very bad: ignore request
      FIN;
      Newblock.Next = NIL;               ! Is the last
      Newblock.Pred = Actblock;          ! Backlink
      Actblock.Next = Newblock;          ! Forw. link of old
      Actblock = Newblock;               ! To deal with
      ROOT.Last= Actblock;               ! For later access
      Locindex = 0(31);                  ! where to store data
      Space = BLOCKSIZE;                 ! full size of block available
   FIN;

   Target = Actblock.Array(Locindex);    ! The target address
   IF Space GE Txtlen THEN               ! all will fit
     Bytes_to_go = Txtlen;               ! Take the full incoming text
   ELSE
     Bytes_to_go = Space;                ! Take only a reduced 1st part
   FIN;

! .... Depending on the actual length a speed optimized xfer is selected

   CASE (Bytes_to_go FIT 1(15))//16

     ALT(0)     C1PTRS = Txt; C1PTRT = Target;         ! lame byte by byte
                TO Bytes_to_go REPEAT                  ! max 15
                   CONT C1PTRT = C1PTRS;
                   REFADD(C1PTRT,1);REFADD(C1PTRS,1);
                END;
                Locindex = Locindex+Bytes_to_go;
                Txtlen   = Txtlen-Bytes_to_go;
                Txt = C1PTRS;

     ALT(1)     C16PTRS = Txt; C16PTRT = Target;       ! 16 ... 31
                CONT C16PTRT = C16PTRS;
                Locindex = Locindex+16(31);
                Txtlen = Txtlen-16(31);
                REFADD(C16PTRS,1); Txt = C16PTRS;
  
     ALT(2)     C32PTRS = Txt; C32PTRT = Target;       ! 32 ... 47
                CONT C32PTRT = C32PTRS;
                Locindex = Locindex+32(31);
                Txtlen = Txtlen-32(31);
                REFADD(C32PTRS,1); Txt = C32PTRS;

     ALT(3)     C48PTRS = Txt; C48PTRT = Target;       ! 48 ... 63
                CONT C48PTRT = C48PTRS;
                Locindex = Locindex+48(31);
                Txtlen = Txtlen-48(31);
                REFADD(C48PTRS,1); Txt = C48PTRS;

     ALT(4,5)   C64PTRS = Txt; C64PTRT = Target;       ! 64 ... 95
                CONT C64PTRT = C64PTRS;
                Locindex = Locindex+64(31);
                Txtlen = Txtlen-64(31);
                REFADD(C64PTRS,1); Txt = C64PTRS;

     ALT(6,7)   C96PTRS = Txt; C96PTRT = Target;       ! 96 ... 127
                CONT C96PTRT = C96PTRS;
                Locindex = Locindex+96(31);
                Txtlen = Txtlen-96(31);
                REFADD(C96PTRS,1); Txt = C96PTRS;

     ALT(8,9)   C128PTRS = Txt; C128PTRT = Target;     ! 128 ... 159
                CONT C128PTRT = C128PTRS;
                Locindex = Locindex+128(31);
                Txtlen = Txtlen-128(31);
                REFADD(C128PTRS,1); Txt = C128PTRS;

     ALT(10,11) C160PTRS = Txt; C160PTRT = Target;     ! 160 ... 191
                CONT C160PTRT = C160PTRS;
                Locindex = Locindex+160(31);
                Txtlen = Txtlen-160(31);
                REFADD(C160PTRS,1); Txt = C160PTRS;

     OUT        C192PTRS = Txt; C192PTRT = Target;     ! 192 ... oo 
                CONT C192PTRT = C192PTRS;
                Locindex = Locindex+192(31);
                Txtlen = Txtlen-192(31);
                REFADD(C192PTRS,1); Txt = C192PTRS; 

   FIN;

 END;   ! while Textlen > 0

END;


! *******************************************************************
! * BESCHREIBUNG : NETSTERR (NETZ STATUS ERROR) ANALYSIERT DEN      *
! *                UEBERGEBENEN TCP/IP FEHLERCODE, UND GIBT DIESEN  *
! *                IM KLARTEXT AUS. DAZU WIRD VOM FEHLERCODE DAS    *
! *                MSB(MOST SIGNIFICANT BIT) ENTFERNT UND DANN ALS  * 
! *                FIXED(15) ZURUECKGEGEBEN.                        *
! *                AUSGEGEBEN WIRD DIE MELDUNG AUF DER JEWEILS      *
! *                ANGEGEBENEN DATION, HIER IM BEISPIEL TERM.       *
! *-----------------------------------------------------------------*
! * BEISPIEL : ...                                                  *
! *            SYSTEM;                                              *
! *               TERM: /TY;                                        *
! *            ...                                                  *
! *            PROBLEM;                                             *
! *            SPC TERM DATION INOUT ALPHIC;                        *
! *            ...                                                  *
! *            DCL ERROR FIXED(15);                                 *
! *            DCL NETST FIXED(15);                                 *
! *            ...                                                  *
! *            #INCLUDE NETSTERR.INC                                *
! *            ...                                                  *
! *            ERROR=NETSTERR(NETST,'0'B,TERM); ! OHNE AUSGABE      *
! *            ERROR=NETSTERR(NETST,'1'B,TERM); ! MIT AUSGABE       *
! *            ...                                                  *
! *                                                                 *
! *-----------------------------------------------------------------*
! * AUTOR            : LARS SCHREINER                               *
! * ERSTELLT         : 29.04.1998                                   *
! * LETZTE AENDERUNG : 07.05.1998                                   *
! *******************************************************************

NETSTERR: PROC(NETSTATUS FIXED(15),AUSGABE BIT(1),TY DATION OUT ALPHIC IDENT)
              RETURNS(FIXED(15));

                                    /* DAZU GEHOERENDER NETSTATUS (NETST):   */
DCL SOEGEN     INV FIXED INIT(  1); /* GENERIC ERROR           (NETST=-32767)*/
DCL SOEAIU     INV FIXED INIT(  2); /* ALREADY IN USE          (NETST=-32766)*/
DCL SOEINV     INV FIXED INIT(  3); /* INVALID HANDLE          (NETST=-32765)*/
DCL SOENOP     INV FIXED INIT(  4); /* SOCKET NOT OPEN         (NETST=-32764)*/
DCL SOEUPF     INV FIXED INIT(  5); /* UNKNOWN PROTOCOL FAMILY (NETST=-32763)*/
DCL SOEIST     INV FIXED INIT(  7); /* INVALID SOCKET TYPE     (NETST=-32761)*/
DCL SOEIPN     INV FIXED INIT(  8); /* INVALID PROTOCOL NUMBER (NETST=-32760)*/
DCL SOEIC      INV FIXED INIT(  9); /* INVALID COMMAND         (NETST=-32759)*/
DCL SOEACL     INV FIXED INIT( 10); /* ALREADY CLOSED          (NETST=-32758)*/
DCL SOEACO     INV FIXED INIT( 11); /* ALREADY CONNECTED       (NETST=-32757)*/
DCL SOEABO     INV FIXED INIT( 12); /* ALREADY BOUND           (NETST=-32756)*/
DCL SOEPRM     INV FIXED INIT( 13); /* PARAMETER ERROR         (NETST=-32755)*/
DCL SOENAB     INV FIXED INIT( 14); /* NO ADRESS BOUND         (NETST=-32754)*/
DCL SOEEOF     INV FIXED INIT( 15); /* END OF FILE             (NETST=-32753)*/
DCL SOEQLE     INV FIXED INIT( 16); /* QUEUE LENGTH EXCEEDED   (NETST=-32752)*/
DCL SOERST     INV FIXED INIT(256); /* RESET                   (NETST=-32512)*/
DCL SOETIM     INV FIXED INIT(257); /* TIMEOUT                 (NETST=-32511)*/
DCL SOEIDU     INV FIXED INIT(258); /* DESTINATION UNREACHABLE (NETST=-32710)*/

DCL VOIDPTR1 REF INV STRUCT[];    ! For text 1
DCL VOIDPTR2 REF INV STRUCT[];    ! For text 2
DCL C255PTR  REF INV CHAR(255);
DCL TXLEN FIXED;


IF NETSTATUS < 0 THEN
   NETSTATUS=TOFIXED(TOBIT(NETSTATUS) AND '7FFF'B4);

   IF AUSGABE THEN  ! WENN AUSGABE AUF '1' GESETZT IST DANN GIB 
                            ! FEHLER IM KLARTEXT AUS!
      CASE NETSTATUS

      ALT (SOEGEN) VOIDPTR1 = '1 = Generic error.';
                   VOIDPTR2 = 'No further info available.';
   
      ALT (SOEAIU) VOIDPTR1 = '2 = Already in use.';
                   VOIDPTR2 = 'If OPEN/BIND/CONNECT: socket/port/prot already in use.';
   
      ALT (SOEINV) VOIDPTR1 = '3 = Invalid Handle.';
                   VOIDPTR2 = 'Handle outside range 0 ... 31.';

      ALT (SOENOP) VOIDPTR1 = '4 = Socket not open.';
                   VOIDPTR2 = 'Socket was not opened before.';

      ALT (SOEUPF) VOIDPTR1 = '5 = Unknown protocol family.';
                   VOIDPTR2 = 'Unsupported prot-family with RESERVE.';
   
      ALT (SOEIST) VOIDPTR1 = '7 = Invalid socket type.';
                   VOIDPTR2 = 'Unsupported socket type with RESERVE.';

      ALT (SOEIPN) VOIDPTR1 = '8 = Invalid protocol number.';
                   VOIDPTR2 = 'Incompatible or unknown with RESERVE.';

      ALT (SOEIC)  VOIDPTR1 = '9 = Invalid command.';
                   VOIDPTR2 = 'Wrong socket state or unknown command.';

      ALT (SOEACL) VOIDPTR1 = '10 = Already closed.';
                   VOIDPTR2 = 'Socket closed before by SHUTDOWN or CLOSE.';

      ALT (SOEACO) VOIDPTR1 = '11 = Already connected.';
                   VOIDPTR2 = 'Socket is already bound by CONNECT.';
   
      ALT (SOEABO) VOIDPTR1 = '12 = Already bound.';
                   VOIDPTR2 = 'Socket is already bound by BIND.';

      ALT (SOEPRM) VOIDPTR1 = '13 = Parameter error.';
                   VOIDPTR2 = 'Parameters (Length etc.) invalid.';

      ALT (SOENAB) VOIDPTR1 = '14 = No address bound.';
                   VOIDPTR2 = 'Command refused: Socket not bound to an address.';
   
      ALT (SOEEOF) VOIDPTR1 = '15 = End of file.';
                   VOIDPTR2 = 'Remote host has already closed connection.';

      ALT (SOEQLE) VOIDPTR1 = '16 = Queue length exceeded.';
                   VOIDPTR2 = 'Command refused: Capacity of queue exceeded.';
   
      ALT (SOERST) VOIDPTR1 = '256 = Reset.';
                   VOIDPTR2 = 'Remote host did reset the connection.';
   
      ALT (SOETIM) VOIDPTR1 = '257 = Timeout.';
                   VOIDPTR2 = 'Due to exceeded time-limit connection is reset.';
   
      ALT (SOEIDU) VOIDPTR1 = '258 = Destination unreachable.';
                   VOIDPTR2 = 'Connection is reset, remote host unreachable.';

      OUT          VOIDPTR1 = NIL;
                   VOIDPTR2 = 'Error-number out of range, no info available.';

      FIN;

      IF NETSTATUS NE SOEINV THEN
      /* 
       * Fehler 3 nicht ausgeben, da ggf. der Client die Verbindung
       * geschlossen hat, d.h. es liegt kein Fehler vor!
       */
      IF VOIDPTR1 ISNT NIL THEN
        C255PTR = VOIDPTR1;
        TXLEN = INSTR(C255PTR,1,255,'.',1,1);
        PUT C255PTR TO TY BY A(TXLEN),SKIP;

      ELSE

        PUT NETSTATUS,' = ???' TO TY BY F(8),A,SKIP;
      FIN;

      C255PTR = VOIDPTR2;
      TXLEN = INSTR(C255PTR,1,255,'.',1,1);
      PUT C255PTR TO TY BY A(TXLEN),SKIP;
    FIN ;
   FIN; /*IF AUSGABE THEN  */



   RETURN(NETSTATUS);

ELSE

   RETURN(0);

FIN; /* IF NETSTATUS < 0 THEN */

END; /* NETSTERR */


! *******************************************************************
! *       SENDFILE send a file to the client                        *
! *-----------------------------------------------------------------*
! * Required subroutines:                  FILEERR.INC              *
! *                                        NETLNK.SR                *
! *                                                                 *
! *-----------------------------------------------------------------*
! * Author: W. Gerth 24.03.2000                                     *
! *-----------------------------------------------------------------*
! * Last modification: 24.03.2000                                   *
! *******************************************************************

SENDFILE: PROC /*+G*/ 
           ( CHILD FIXED,
                FILEINFO FILEPACK IDENT,
                stderr DATION OUT ALPHIC IDENT,
                loglink DATION OUT ALPHIC IDENT
              ) GLOBAL;

   DCL BUFFER(1000) CHAR(1);     ! The internal buffer
   DCL SCRATCH REF DATION INOUT ALPHIC;
   DCL filestate             FIXED(15);
   DCL ILEN                  FIXED(31);  ! Incoming data len
   DCL COUNTER               FIXED(31);  ! total no of bytes

   DCL NETERROR              FIXED(15)     INIT(0);
   DCL NETST                 FIXED;
   DCL Fname REF CHAR(255);              ! For fast access only
   DCL Fnamelen FIXED;
   #IF MAXILOG 
     WRITE 'S: SENDFILE starting.' TO loglink;
   #FIN;

   SCRATCH = FILEINFO.DatPTR;    ! For faster access only

   ILEN = 1 UPB BUFFER; COUNTER = 0(31);

   WHILE ILEN > 0(31) REPEAT
         ILEN = 1 UPB BUFFER;
         READ BUFFER FROM SCRATCH BY S(ILEN);
         filestate:=ST(SCRATCH);
         IF ILEN > 0(31) THEN
           NETST=NETLINK(CHILD,BUFFER(1).CHAR(1),ILEN FIT 1(15),SO_WRITE,FLG_PUSH+FLG_WAIT,stderr,loglink);
           NETERROR=NETSTERR(NETST,'1'B,stderr);
           IF NETERROR NE 0 AND NETERROR NE 3 THEN
             WRITE 'HTTP-USER: NETERROR in SENDFILE SO_WRITE'\0D0A\''
                   TO stderr;
             #IF MAXILOG+MINILOG
               WRITE 'S: NETERROR in SENDFILE SO_WRITE.' TO loglink; 
               NETERROR=NETSTERR(NETST,'1'B,loglink);
             #FIN;
             ILEN = 0(31);
           FIN; /* IF NETERROR NE 0 THEN */
           COUNTER = COUNTER+ILEN;
         ELSE 
           IF filestate GT 1 THEN
              #IF MAXILOG+MINILOG
               WRITE 'S: READ-Error in SENDFILE.' TO loglink; 
               FileErr(filestate,loglink);
              #FIN;
           FIN; ! if filestate ...
         FIN;  ! if ILEN > 0;
   END; ! WHILE REPEAT

! .................... Leaving Sendfile .......................
   CLOSE SCRATCH;
   filestate:=ST(SCRATCH);
   IF (filestate NE 0) THEN
      Fname = FILEINFO.Name; Fnamelen=LEN(Fname);
      PUT 'HTTP-USER: SENDFILE unable to close file ',Fname
          TO stderr BY A,A(Fnamelen),SKIP;
      PUT 'HTTP-USER: File-error ',filestate TO stderr 
           BY SKIP,A,F(3);
      FileErr(filestate,stderr);
      #IF MAXILOG+MINILOG
        PUT 'S: SENDFILE unable to close file ',Fname
              TO loglink BY A,A(Fnamelen);
        PUT 'S: File-error: ',filestate TO loglink  BY A,F(3);
        FileErr(filestate,loglink);
      #FIN; 
   FIN;   

   #IF MAXILOG 
      PUT 'S: ',COUNTER,' bytes sent.' TO 
           loglink BY A,F(10),A;
      WRITE 'S: SENDFILE terminated.' TO loglink;
   #FIN;! PRAEPROZESSOR-BEFEHL !

END; /*SENDFILE*/


/*******************************************************************/
/* SEND_LISTE sends the list content to the client                 */
/*-----------------------------------------------------------------*/
/* AUTOR : W. Gerth 23.04.2000                                     */
/*******************************************************************/
SEND_LISTE: PROC /*+G*/ 
          ( CHILD FIXED, 
                  ROOT REF LISTE,
                  stderr DATION OUT ALPHIC IDENT,
                  loglink DATION OUT ALPHIC IDENT
                ) GLOBAL ;

  DCL NETST             FIXED(15) ;
  DCL NETERROR          FIXED(15) ;
  DCL Bytes_to_go       FIXED(31) ;
  DCL Actblock      REF LISTE     ;       
  DCL Startadr      REF CHAR(1)   ;

   #IF MAXILOG 
    WRITE 'S: SEND_LISTE starting.' TO loglink;       
   #FIN;

  Bytes_to_go = ROOT.Indexw;
  Actblock=ROOT;

  /*... Due to a bug in the BSD-socket it is faster to use 512-blocks */
  #DEFINE SENDSIZE = 512 ;

  WHILE Actblock ISNT ROOT.Last REPEAT
    Startadr = Actblock.Array(0);
    TO BLOCKSIZE//SENDSIZE REPEAT
      NETST = NETLINK( CHILD, Startadr, SENDSIZE, SO_WRITE , FLG_PUSH+FLG_WAIT,stderr,loglink ) ;
      NETERROR = NETSTERR( NETST, '1'B, stderr ) ;
      IF NETERROR NE 0 AND NETERROR NE 3 THEN
        /* Wird das Port von der Gegenseite geschlossen (NETERROR=3) so ist das kein Fehler */
        WRITE 'HTTP-USER: NETERROR in SENDLISTE WRITE BLOCKSIZE!'\0D0A\'' TO stderr ;
        #IF MAXILOG+MINILOG 
          WRITE 'S: NETERROR in SENDLISTE WRITE BLOCKSIZE!' TO loglink ;
          NETERROR = NETSTERR( NETST, '1'B, loglink ) ;
        #FIN; 
      FIN ; /* IF NETERROR NE 0 THEN */
      REFADD( Startadr, SENDSIZE ) ;
    END;
     
    Bytes_to_go = Bytes_to_go - BLOCKSIZE ;
    Actblock = Actblock.Next ;
  END ;

  /* ... Last we write the incomplete block ............................*/

  NETST = NETLINK( CHILD, Actblock.Array(0), Bytes_to_go FIT 1(15), SO_WRITE, FLG_PUSH+FLG_WAIT,stderr, loglink ) ;
  
  NETERROR = NETSTERR( NETST, '1'B, stderr ) ;
  IF NETERROR NE 0 AND NETERROR NE 3 THEN
    /* Wird das Port von der Gegenseite geschlossen (NETERROR=3) so ist das kein Fehler */
    WRITE 'HTTP-USER: NETERROR in SENDLISTE WRITE Rest!'\0D0A\'' TO stderr ;
    #IF MAXILOG+MINILOG 
      WRITE 'S: NETERROR in SENDLISTE WRITE Rest!' TO loglink ;
      NETERROR = NETSTERR( NETST, '1'B, loglink ) ;
    #FIN; 
  FIN; /* IF NETERROR NE 0 THEN */

  #IF MAXILOG 
    PUT 'S: (SENDLIST) ', ROOT.Indexw, ' bytes sent.' TO loglink BY A, F(10), A ;
    WRITE 'S: (SENDLIST) leaving.' TO loglink ;
  #FIN; 
END; /* PROC SEND_LISTE */


NETLNK: PROC /*+G*/ ( sock    FIXED ,               /* port number       */
              data    CHAR(1) IDENT,       /* Start adr of data */
              dlen    FIXED,               /* Len of data       */
              cmmd    FIXED,               /* Network command   */
              flag    FIXED,               /* Flags wait=128    */
              stderr  DATION OUT ALPHIC IDENT,
              loglink DATION OUT ALPHIC IDENT
            ) RETURNS(FIXED) GLOBAL;      /* Completion state  */

   DCL ret_val     FIXED      ;
   DCL pdata       TCP_DATA   ;
   DCL xlen        FIXED      ;

   IF sock GT 0 AND sock LE IEP_MAX_PORT THEN 

      CASE cmmd 
      ALT ( SO_WRITE )
         pdata.DATA = data ;
         ret_val = 1 ;

         WHILE ret_val GT 0 AND dlen GT 0 REPEAT ; 
            xlen = dlen ; 
            IF xlen GT 512 THEN xlen = 512 ; FIN;

            ret_val = TCP_send( IEP_CONN( sock ) , pdata , xlen FIT 1(31) ) ;
            IF  ret_val EQ TOFIXED('8084'B4) THEN
               /* TCP Stack full, let him a chance to deliver */
               AFTER 0.1 SEC RESUME ;
               ret_val = 1 ;
            ELSE
               #IF MAXILOG
               PUT 'M: (WRITE=',xlen,') datalen:',TOBIT(ret_val) TO loglink BY A,F(8),A,B4(4) ;
               #FIN
               dlen = dlen - xlen ;
               CALL REFADD( pdata.DATA , xlen );
            FIN ;
         END ;
      ALT ( SO_READ )
         pdata.DATA = data ; 

         xlen = TCP_Nreceive( IEP_CONN( sock ), pdata, dlen FIT 1(31) ) ;
         #IF MAXILOG
         PUT 'M: (READ=',dlen,') datalen:',TOBIT(xlen) TO loglink BY A,F(8),A,B4(4) ;
         #FIN

         ret_val = xlen ;

      ALT ( SO_CLOSE )
         IF IEP_CONN( sock ).STATUS ISNT NIL THEN
!           PUT 'HTTPD close connection by:',sock TO stderr BY A,F(5),SKIP;
            ret_val = TCP_close( IEP_CONN( sock ) ) ;
            IEP_CONN( sock ).STATUS = NIL ;
         FIN;
      OUT /* nicht implementiert */
      FIN ;
   FIN ;
   RETURN( ret_val );

END ; /* PROC NETLNK --------------------------------------------------------*/

IEP_NET_INIT: PROC GLOBAL ;
  FOR i TO IEP_MAX_PORT REPEAT ;
    IEP_CONN( i ).STATUS = NIL ;
  END ;
END ; /* PROC IEP_NET_INIT --------------------------------------------------*/

NET_OPEN: PROC /*+G*/ ( loc_port FIXED            ,  ! local Port HTTP !
                 socket   FIXED      IDENT ,  ! ptr to socketstruct 
                 ipadr    FIXED(31)  IDENT ,  ! rem IP-Adresse on connection 
                 rem_port FIXED      IDENT ,  ! rem Port on connection
                 stderr   DATION OUT ALPHIC IDENT,
                 loglink  DATION OUT ALPHIC IDENT
               ) RETURNS( FIXED) GLOBAL ; 

  DCL ret_val FIXED ;
  DCL index   FIXED INIT(-1) ;

  DCL name CHAR(24);

  /* search a free channel */

  FOR i TO IEP_MAX_PORT WHILE index EQ -1 REPEAT ;
    IF IEP_CONN( i ).STATUS IS NIL THEN
      index = i ;
    FIN ;
  END;

  IF index GT 0 THEN
    /* do a passive open and wait for Connection */
    name = ' ';

    http_demon_zahl = http_demon_zahl + 1 ;
    IF http_demon_zahl GT 255 THEN http_demon_zahl = 0 ; FIN ;

    CONVERT 'HTTPD_', TOBIT(index), '/', TOBIT(http_demon_zahl) TO name BY A,B4(4),A,B4;

!   PUT 'HTTPD Wait for connection by:',name TO stderr BY A,A,SKIP;

    IEP_CONN( index ) = TCP_passive_open( 0(31), 0, loc_port, 0(31), name.CHAR(1) ) ;

    IF IEP_CONN( index ).STATUS ISNT NIL THEN
      ret_val  = index ; /* setze virt. Port ein */
      socket   = index ; 
      ipadr    = TOFIXED( IEP_CONN( index ).STATUS.DEST_ADDR ) ;
      rem_port =  IEP_CONN( index ).STATUS.DEST_PORT ;
      #IF MAXILOG
        PUT 'M: (OPEN) from',TOBIT(ipadr) TO loglink BY A,B4(8) ;
      #FIN
    ELSE
      /* keine Verbindung */
      ipadr    = 0  ;
      rem_port = 0  ;
      socket   = -1 ;  
      ret_val  = TOFIXED('8001'B4) ;
    FIN ;
  ELSE
    /* keine Verbindung */
    ipadr    = 0  ;
    rem_port = 0  ;
    socket   = -1 ;  
    ret_val  = TOFIXED('8002'B4) ;
  FIN ;   

  RETURN( ret_val );

END ; /* PROC NET_OPEN ------------------------------------------------------*/




MODEND; /* HTTPLIB */