
#IFUDEF HTTPLIB_H_INCLUDED ;
#DEFINE HTTPLIB_H_INCLUDED = 1 ;

  TYPE  TCP_SOCKET STRUCT  (/ STATUS REF TCP_STAT /) ;

   TYPE  TCP_DATA   STRUCT  (/ DATA   REF CHAR(1)  /) ;
  TYPE  SLISTE    STRUCT  [ ROOT   REF LISTE     ] ;

  TYPE LISTE STRUCT[ Array(0:BLOCKSIZE-1) CHAR(1),  ! The Buffer
                     Next REF LISTE,                ! Next element
                     Pred REF LISTE,                ! Predecessor
                     Last REF LISTE,                ! used only in root
                     Indexw FIXED(31),              ! writer idx, root only
                     Indexr FIXED(31),              ! reader idx, root only
                     datptr REF CHAR(1) ,           ! ptr to real DATA !! only First Block
                     datlen FIXED(31) ,             ! len of real DATA !! only First Block
                     headlen FIXED(31)              ! len of Header    !! only First Block
                   ] ;

  TYPE FILEPACK STRUCT[ Name CHAR(255),        ! Full name of file
                 DatPTR REF DATION INOUT ALPHIC,  ! Pointer to Dation
                 Status FIXED(15),                ! Status of dation
                 Content CHAR(128),               ! Content-type
                 Length  FIXED(31),               ! Length of the file
                 DateTime CHAR(20)                ! Data from Touch
                ] ;

  SPC FREE     PROC(REF STRUCT[] IDENT)    GLOBAL;
   SPC MALLOC   PROC(FIXED(31),FIXED) RETURNS(REF STRUCT[]) GLOBAL;
  SPC DATE     ENTRY RETURNS(CHAR(10)) GLOBAL;

   /*                                               */
   /* PEARL - TCP - ENTRIES                         */
   /*                                               */

  SPC TCP_close        ENTRY( TCP_SOCKET IDENT )
                        RETURNS( FIXED(15) ) GLOBAL;

   SPC TCP_send         ENTRY( TCP_SOCKET IDENT , TCP_DATA IDENT , FIXED(31) )
                        RETURNS( FIXED(15) ) GLOBAL;

   SPC TCP_receive      ENTRY( TCP_SOCKET IDENT , TCP_DATA IDENT )
                        RETURNS( FIXED(15) ) GLOBAL;

   SPC TCP_Nreceive     ENTRY( TCP_SOCKET IDENT , TCP_DATA IDENT, FIXED(31) )
                        RETURNS( FIXED(15) ) GLOBAL;

   SPC TCP_passive_open ENTRY( FIXED(31) , FIXED(15) ,
                               FIXED(15) , FIXED(31) ,
                               CHAR(1) IDENT  )
                        RETURNS( TCP_SOCKET ) GLOBAL;


/* exportierte Funktionen/Prozeduren */
SPC DATE_EQU    ENTRY( (BUFFER,TOUCH_DATA) CHAR(50),
                 loglink DATION OUT ALPHIC IDENT
                ) RETURNS( BIT(1) ) GLOBAL ;

SPC SCHALTJAHR    ENTRY( JAHR FIXED(15) )         RETURNS( FIXED(15) ) GLOBAL;
SPC TAGESNUMMER ENTRY( (JAHR,MONAT,TAG) FIXED(15) ) RETURNS( FIXED(15) ) GLOBAL ;
SPC WOCHENTAG   ENTRY( (JAHR,TAGNUMMER) FIXED(15) ) RETURNS( FIXED(15) ) GLOBAL;
SPC TAGNAME     ENTRY( (TAG,MONAT,JAHR) FIXED(15) ) RETURNS( CHAR(10)  ) GLOBAL;

SPC FileErr     ENTRY( ERROR FIXED (15),TY DATION OUT ALPHIC IDENT)     GLOBAL ;

SPC FILELENGTH    ENTRY( FILENAME     CHAR(255) IDENT,
                 CONTENT_TYPE   CHAR(255) IDENT,
                 METHOD_OR_ERROR  CHAR(255) IDENT,
                 stdout       DATION INOUT ALPHIC IDENT,
                 stderr       DATION INOUT ALPHIC IDENT,
                 file2        DATION INOUT ALPHIC IDENT,
                 loglink        DATION   OUT ALPHIC IDENT
                )
                RETURNS(FIXED(31)) GLOBAL;

SPC HEADER      ENTRY( CHILD        FIXED,
                 LAENGESTR      CHAR(12) IDENT,
                 CONTENTTYPE    CHAR(255),
                 METHOD_OR_ERROR  FIXED IDENT,
                 LASTMODDATE    CHAR(10),
                 LASTMODTIME    CHAR(8),
                 stderr       DATION OUT ALPHIC IDENT,
                 loglink        DATION OUT ALPHIC IDENT
                ) GLOBAL;

SPC RM_LIST     ENTRY( ROOT         REF LISTE IDENT,
                 loglink        DATION OUT ALPHIC IDENT
                ) GLOBAL;

SPC WRITE_TO_LIST ENTRY( ROOT         REF LISTE IDENT,
                         Txt          REF INV STRUCT[],
                         Txtlen       FIXED(31),
                         loglink        DATION OUT ALPHIC IDENT
                       ) GLOBAL;

SPC SENDFILE    ENTRY( CHILD        FIXED,
                 FILEINFO     FILEPACK IDENT,
                 stderr       DATION OUT ALPHIC IDENT,
                 loglink        DATION OUT ALPHIC IDENT
                ) GLOBAL;

SPC SEND_LISTE    ENTRY( CHILD        FIXED,
                 ROOT         REF LISTE,
                 stderr       DATION OUT ALPHIC IDENT,
                 loglink        DATION OUT ALPHIC IDENT
                ) GLOBAL ;

#IF IEP_SOCKET > 0 ;

 SPC NETLNK ENTRY(FIXED,         ! port number
                  CHAR(1) IDENT, ! Start adr of data
                  FIXED,         ! Len of data
                  FIXED,         ! Network command
                  FIXED,         ! Flags wait=128
                  DATION OUT ALPHIC IDENT,
                  DATION OUT ALPHIC IDENT
                 )
     RETURNS(FIXED) GLOBAL;      ! Completion state

 SPC NET_OPEN ENTRY ( FIXED           ,  ! local Port HTTP !
                      FIXED     IDENT ,  ! ptr on Socketstruct
                      FIXED(31) IDENT ,  ! rem IP-Adresse on connection
                      FIXED     IDENT ,  ! rem Port on connection
                      FIXED(31)  IDENT ,  ! own IP-Adresse on connection
                      FIXED      IDENT ,  ! own Port on connection
                      DATION OUT ALPHIC IDENT,
                      DATION OUT ALPHIC IDENT
                    ) RETURNS( FIXED) GLOBAL ;

#ELSE

 SPC NETLNK ENTRY(FIXED,         ! port number
                  CHAR(1) IDENT, ! Start adr of data
                  FIXED,         ! Len of data
                  FIXED,         ! Network command
                  FIXED          ! Flags wait=128
                 )
     RETURNS(FIXED) GLOBAL;      ! Completion state

#FIN


/* exportierte Daten */
! For DATE_EQ:
#IFDEF THIS_IS_HTTPLIB
  DCL MSTR1 INV CHAR(36) GLOBAL INIT('JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC') ;
  DCL MSTR2 INV CHAR(36) GLOBAL INIT('JanFebMarAprMayJunJulAugSepOctNovDec') ;
#ELSE
  SPC MSTR1 INV CHAR(36) GLOBAL ;
  SPC MSTR2 INV CHAR(36) GLOBAL ;
#FIN ;

! For creation of dayname:
#IFDEF THIS_IS_HTTPLIB
   DCL DAYNAME(0:6) INV CHAR(10) GLOBAL
    INIT( 'Sunday    ','Monday    ', 'Tuesday   ','Wednesday ',
            'Thursday  ','Friday    ','Saturday  '
       ) ;
#ELSE
   SPC DAYNAME(0:6) INV CHAR(10)  GLOBAL ;
#FIN ;

! For creation of monthname:
#IFDEF THIS_IS_HTTPLIB
   DCL MONATNAME(1:12) INV CHAR(3) GLOBAL
       INIT( 'Jan','Feb','Mar','Apr','May','Jun',
             'Jul','Aug','Sep','Oct','Nov','Dec'
        ) ;
#ELSE
   SPC MONATNAME(1:12) INV CHAR(3) GLOBAL ;
#FIN ;

! General purpose constants:
#IFDEF THIS_IS_HTTPLIB
  DCL (TRUE,FALSE) INV BIT(1) GLOBAL INIT('1'B,'0'B)  ;
#ELSE
  SPC (TRUE,FALSE) INV BIT(1) GLOBAL ;
#FIN ;

! For METHOD_OR_ERROR:
#IFDEF THIS_IS_HTTPLIB
   DCL M_NONE               INV FIXED GLOBAL INIT(0)   ;  ! 'None'
   DCL M_FAIL               INV FIXED GLOBAL INIT(1)   ;  ! 'fail'
   DCL M_BADRQ              INV FIXED GLOBAL INIT(2)   ;  ! 'bad request'
   DCL M_FNF                INV FIXED GLOBAL INIT(3)   ;  ! 'file not found'
   DCL M_GET_N              INV FIXED GLOBAL INIT(4)   ;  ! 'get file no specials'
   DCL M_GET_FNM            INV FIXED GLOBAL INIT(5)   ;  ! 'get file not modified'
   DCL M_GET_FMO            INV FIXED GLOBAL INIT(6)   ;  ! 'get file modified'
   DCL M_GET_AP             INV FIXED GLOBAL INIT(7)   ;  ! 'get from application'
   DCL M_POST_UP            INV FIXED GLOBAL INIT(8)   ;  ! 'POST /UPLOAD
   DCL M_POST_AP            INV FIXED GLOBAL INIT(9)   ;  ! 'POST /Appl.
   DCL M_PUT                INV FIXED GLOBAL INIT(10)  ;  ! 'PUT' file
#ELSE
   SPC M_NONE               INV FIXED GLOBAL ;  ! 'None'
   SPC M_FAIL               INV FIXED GLOBAL ;  ! 'fail'
   SPC M_BADRQ              INV FIXED GLOBAL ;  ! 'bad request'
   SPC M_FNF                INV FIXED GLOBAL ;  ! 'file not found'
   SPC M_GET_N              INV FIXED GLOBAL ;  ! 'get file no specials'
   SPC M_GET_FNM            INV FIXED GLOBAL ;  ! 'get file not modified'
   SPC M_GET_FMO            INV FIXED GLOBAL ;  ! 'get file modified'
   SPC M_GET_AP             INV FIXED GLOBAL ;  ! 'get from application'
   SPC M_POST_UP            INV FIXED GLOBAL ;  ! 'POST /UPLOAD
   SPC M_POST_AP            INV FIXED GLOBAL ;  ! 'POST /Appl.
   SPC M_PUT                INV FIXED GLOBAL ;  ! 'PUT' file
#FIN ;


! For NETLINK :
#IFDEF THIS_IS_HTTPLIB
   DCL (SO_OPEN,SO_RESERVE,SO_CLOSE,SO_BIND)    INV FIXED GLOBAL INIT(0,1,2,3);
   DCL (SO_CONNECT,SO_SHUT,SO_LISTEN,SO_ACCEPT) INV FIXED GLOBAL INIT(4,5,6,7);
   DCL (SO_READFROM,SO_READ,SO_WRITETO)         INV FIXED GLOBAL INIT(8,9,10);
   DCL (SO_WRITE,SO_SETOPT,SO_GETREMADDR)       INV FIXED GLOBAL INIT(11,12,13);
#ELSE
   SPC (SO_OPEN,SO_RESERVE,SO_CLOSE,SO_BIND)    INV FIXED GLOBAL ;
   SPC (SO_CONNECT,SO_SHUT,SO_LISTEN,SO_ACCEPT) INV FIXED GLOBAL ;
   SPC (SO_READFROM,SO_READ,SO_WRITETO)         INV FIXED GLOBAL ;
   SPC (SO_WRITE,SO_SETOPT,SO_GETREMADDR)       INV FIXED GLOBAL ;
#FIN ;

#IFDEF THIS_IS_HTTPLIB
  DCL PF_INET              INV FIXED GLOBAL INIT(2);    ! Protocol family
   DCL AF_INET              INV FIXED GLOBAL INIT(2);
   DCL FLG_ABORT            INV FIXED GLOBAL INIT(1);
   DCL FLG_PUSH             INV FIXED GLOBAL INIT(1);
   DCL FLG_WAIT             INV FIXED GLOBAL INIT(128);
   DCL SOCK_STREAM          INV FIXED GLOBAL INIT(1);
#ELSE
  SPC PF_INET              INV FIXED GLOBAL ;    ! Protocol family
   SPC AF_INET              INV FIXED GLOBAL ;
   SPC FLG_ABORT            INV FIXED GLOBAL ;
   SPC FLG_PUSH             INV FIXED GLOBAL ;
   SPC FLG_WAIT             INV FIXED GLOBAL ;
   SPC SOCK_STREAM          INV FIXED GLOBAL ;
#FIN ;


#FIN;
