! *******************************************************************
!  The following variable list is preset upon start-up              *
!  by the Initialisation package                                    *
!                                                                   *
!  !!! The table-version must match that of the HTTP_Demon !!!      *
!********************************************************************

TYPE VARENTRY STRUCT[Name   CHAR(24),          ! Name of variable
                     Descr  FIXED,             ! What type of
                     Len    FIXED,             ! Len of Text i/a
                     IValue FIXED(31)];        ! Integ value or textindx
!
! ... The following arrays are exported to a file HTTPSERV.FRM
!     which will be taken by the Task HTTP_Demon if the Tabversion
!     is identical.
DCL Tabversionreq CHAR(8) INIT('15052006');    ! Must match

! ... The Descriptor .Descr is defined as follows:
#DEFINE vtIgnore          = -1   !  internal use for searching
#DEFINE vtUnused          =  0   !  unused entry
#DEFINE vtNumVal          =  1   !  Pure numeric value
#DEFINE vtTextStr         =  2   !  Text string
#DEFINE vtIPAddr          =  3   !  IP adr or mask 32 bit Fixed
#DEFINE vtNewFileType     =  4   !  New file type definition
#DEFINE vtNewApplication  =  5   !  New application definition
#DEFINE vtNewApplication2 =  6   !  New application definition
#DEFINE vtNewApplication3 =  7   !  New application definition
#DEFINE vtNewDirAlias     =  8   !  New directory alias definition
#DEFINE vtNewRealm        =  9   !  New realm definition
#DEFINE vtNewAuthenticate = 10   !  New authenticate definition
#DEFINE vtFileType        = 11   !  File type = text string
#DEFINE vtApplication     = 12   !  Application = text string
#DEFINE vtApplication2    = 13   !  Application = text string
#DEFINE vtApplication3    = 14   !  Application = text string
#DEFINE vtDirAlias        = 15   !  Directory alias = text string
#DEFINE vtRealm           = 16   !  Realm = text string (userid:password)
#DEFINE vtAuthenticate    = 17   !  Dir/App = text string (realm)

#DEFINE VARTABLEN = 128
#DEFINE TXTPOOLLEN = 128

#IF INIT_TEMPLATES ;
DCL VARTABINIT (VARTABLEN) VARENTRY INIT(
          'OWN_IP',    vtIPAddr,0,0,            ! Own IP-Adr, must be 1st
          'APPLICATION',vtNewApplication,0,0,   ! For new application
          'APPLICATION2',vtNewApplication2,0,0, ! For new application
          'APPLICATION3',vtNewApplication3,0,0, ! For new application
          'FILETYPE',  vtNewFileType,0,0,       ! For new filetype definition
          'DIRALIAS',  vtNewDirAlias,0,0,       ! For new alias directory
          'REALM',     vtNewRealm,0,0,          ! For new realm
          'AUTHENTICATE', vtNewAuthenticate,0,0,! For new authenticate
          'QLEN',      vtNumVal,0,32,           ! Socket Queue-len
          'IP_ALLOW1', vtIPAddr,0,0,            ! Allowed IP-Group
          'IP_MASK1',  vtIPAddr,0,-256,         ! Mask used
          'IP_ALLOW2', vtIPAddr,0,0,            ! Allowed IP-Group
          'IP_MASK2',  vtIPAddr,0,-256,         ! Mask 2
          '.HTM',      vtFileType,9,1,          ! File-type
          '.GIF',      vtFileType,9,2,          ! File type
          '.PNG',      vtFileType,9,3,          ! File type
          '.JPG',      vtFileType,10,4,         ! File type
          '.TXT',      vtFileType,10,5,         ! File type
          '.JPEG',     vtFileType,10,4,         ! File type
          '.HTML',     vtFileType,9,1,          ! File type
          '*',         vtUnused,0,0);           ! Free for insertion

DCL TxtPoolInit(TXTPOOLLEN) CHAR(10) INIT( 'text/html ',
                                           'image/gif ',
                                           'image/png ',
                                           'image/jpeg',
                                           'text/plain',
                                           ' ');

#FIN;

DCL IP_ALLOW1_IDX INV FIXED INIT(10);           ! Check above
DCL IP_ALLOW2_IDX INV FIXED INIT(12);           ! Check above
DCL IP_MASK1_IDX INV FIXED INIT( 11);           ! Check above
DCL IP_MASK2_IDX INV FIXED INIT(13);            ! Check above
DCL OWN_IP_IDX INV FIXED INIT(1);               ! Check above
DCL Q_LEN_IDX  INV FIXED INIT(9);               ! Check obove


! Interne Variablen zum Parsen des INI-Files
#IF INIT_TEMPLATES ;

DCL EmptySlot VARENTRY INIT( '*', vtUnused, 0, 0 ) ;
DCL EMPTY CHAR(24) INIT('*                       '); ! Empty slot

! Translation-map for Base64-Encoding
! DCL Base64Encoding INV CHAR(64) INIT('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/');

#FIN;
