   TYPE TCP_STAT STRUCT (/  DEST_ADDR    BIT(32)     ,
                            SOURCE_PORT  FIXED(15)   ,
                            DEST_PORT    FIXED(15)   ,
                            TIME_OUT     FIXED(31)   ,
                            F_NAME       CHAR(32)    ,
                            SOURCE_ADDR  BIT(32)     ,
                            PUSH_FLAG    FIXED(15)   ,
                            URG_FLAG     FIXED(15)   ,
                            SND_WND      FIXED(31)   ,
                            RCV_WND      FIXED(31)   ,
                            T_STATE      FIXED(15)
                        /);

   /*                                               */
   /* UEBERGABE STRUCTUREN AN DAS TCP               */
   /*                                               */
   TYPE  TCP_SOCKET STRUCT  (/ STATUS REF TCP_STAT /) ;
   TYPE  TCP_DATA   STRUCT  (/ DATA   REF CHAR(1)  /) ;
   /*                                               */
   /* PEARL - TCP - ENTRIES                         */
   /*                                               */
   SPC TCP_close        ENTRY( TCP_SOCKET IDENT )
                        RETURNS( FIXED(15) ) GLOBAL;
   SPC TCP_send         ENTRY( TCP_SOCKET IDENT , TCP_DATA IDENT , FIXED(31) )
                        RETURNS( FIXED(15) ) GLOBAL;
   SPC TCP_receive      ENTRY( TCP_SOCKET IDENT , TCP_DATA IDENT )
                        RETURNS( FIXED(15) ) GLOBAL;
   SPC TCP_Nreceive     ENTRY( TCP_SOCKET IDENT , TCP_DATA IDENT, FIXED(31) )
                        RETURNS( FIXED(15) ) GLOBAL;
   SPC TCP_passive_open ENTRY( FIXED(31) , FIXED(15) ,
                               FIXED(15) , FIXED(31) ,
                               CHAR(1) IDENT  )
                        RETURNS( TCP_SOCKET ) GLOBAL;
   SPC TCP_set_timeout  ENTRY( TCP_SOCKET IDENT , FIXED(31) ) GLOBAL;


   DCL IEP_MAX_PORT INV FIXED INIT( 64 ) ;

   DCL IEP_CONN( IEP_MAX_PORT ) TCP_SOCKET ;

   DCL http_demon_zahl FIXED INIT(0) ; /* Erzeugt den Filenamen von 0-255 */

NETLNK: PROC( sock    FIXED ,               /* port number       */
              data    CHAR(1) IDENT,       /* Start adr of data */
              dlen    FIXED,               /* Len of data       */
              cmmd    FIXED,               /* Network command   */
              flag    FIXED,               /* Flags wait=128    */
              stderr  DATION OUT ALPHIC IDENT,
              loglink DATION OUT ALPHIC IDENT
            ) RETURNS(FIXED) GLOBAL;      /* Completion state  */

   DCL ret_val     FIXED      ;
   DCL pdata       TCP_DATA   ;
   DCL xlen        FIXED      ;

   IF sock GT 0 AND sock LE IEP_MAX_PORT THEN

      CASE cmmd
      ALT ( SO_WRITE )
         pdata.DATA = data ;
         ret_val = 1 ;

         WHILE ret_val GT 0 AND dlen GT 0 REPEAT ;
            xlen = dlen ;
            IF xlen GT 512 THEN xlen = 512 ; FIN;

            ret_val = TCP_send( IEP_CONN( sock ) , pdata , xlen FIT 1(31) ) ;
            IF  ret_val EQ TOFIXED('8084'B4) THEN
               /* TCP Stack full, let him a chance to deliver */
               AFTER 0.1 SEC RESUME ;
               ret_val = 1 ;
            ELSE
               #IF MAXILOG
               PUT 'M: (WRITE=',xlen,') datalen:',TOBIT(ret_val) TO loglink BY A,F(8),A,B4(4) ;
               #FIN
               dlen = dlen - xlen ;
               CALL REFADD( pdata.DATA , xlen );
            FIN ;
         END ;
      ALT ( SO_READ )
         pdata.DATA = data ;

         xlen = TCP_Nreceive( IEP_CONN( sock ), pdata, dlen FIT 1(31) ) ;
         #IF MAXILOG
         PUT 'M: (READ=',dlen,') datalen:',TOBIT(xlen) TO loglink BY A,F(8),A,B4(4) ;
         #FIN

         ret_val = xlen ;

      ALT ( SO_CLOSE )
         IF IEP_CONN( sock ).STATUS ISNT NIL THEN
!           PUT 'HTTPD close connection by:',sock TO stderr BY A,F(5),SKIP;
            ret_val = TCP_close( IEP_CONN( sock ) ) ;
            IEP_CONN( sock ).STATUS = NIL ;
         FIN;
      OUT /* nicht implementiert */
      FIN ;
   ELSE
     RETURN( TOFIXED('8003'B4 ) ); ! Invalid Handle
   FIN ;
   RETURN( ret_val );

END ; /* PROC NETLNK --------------------------------------------------------*/

IEP_NET_INIT: PROC GLOBAL ;
  FOR i TO IEP_MAX_PORT REPEAT ;
    IEP_CONN( i ).STATUS = NIL ;
  END ;
END ; /* PROC IEP_NET_INIT --------------------------------------------------*/

NET_OPEN: PROC ( loc_port FIXED            ,  ! local Port HTTP !
                 socket   FIXED      IDENT ,  ! ptr to socketstruct
                 ipadr    FIXED(31)  IDENT ,  ! rem IP-Adresse on connection
                 rem_port FIXED      IDENT ,  ! rem Port on connection
                 ownipadr FIXED(31)  IDENT ,  ! own IP-Adresse on connection
                 own_port FIXED      IDENT ,  ! own Port on connection
                 stderr   DATION OUT ALPHIC IDENT,
                 loglink  DATION OUT ALPHIC IDENT
               ) RETURNS( FIXED) GLOBAL ;

  DCL ret_val FIXED ;
  DCL index   FIXED INIT(-1) ;

  DCL name CHAR(24);

  /* search a free channel */

  FOR i TO IEP_MAX_PORT WHILE index EQ -1 REPEAT ;
    IF IEP_CONN( i ).STATUS IS NIL THEN
      index = i ;
    FIN ;
  END;

  IF index GT 0 THEN
    /* do a passive open and wait for Connection */
    name = ' ';

    http_demon_zahl = http_demon_zahl + 1 ;
    IF http_demon_zahl GT 255 THEN http_demon_zahl = 0 ; FIN ;

    CONVERT 'HTTPD_', TOBIT(index), '/', TOBIT(http_demon_zahl) TO name BY A,B4(4),A,B4;

!   PUT 'HTTPD Wait for connection by:',name TO stderr BY A,A,SKIP;

    IEP_CONN( index ) = TCP_passive_open( 0(31), 0, loc_port, 0(31), name.CHAR(1) ) ;

    IF IEP_CONN( index ).STATUS ISNT NIL THEN
      TCP_set_timeout( IEP_CONN( index ), SERVER_INACTIVE_TIME * 1000(31) );
      ret_val  = index ; /* setze virt. Port ein */
      socket   = index ;
      ipadr    = TOFIXED( IEP_CONN( index ).STATUS.DEST_ADDR ) ;
      rem_port =  IEP_CONN( index ).STATUS.DEST_PORT ;
      ownipadr = TOFIXED( IEP_CONN( index ).STATUS.SOURCE_ADDR ) ;
      own_port =  IEP_CONN( index ).STATUS.SOURCE_PORT ;
      #IF MAXILOG
        PUT 'M: (OPEN) from',TOBIT(ipadr) TO loglink BY A,B4(8) ;
      #FIN
    ELSE
      /* keine Verbindung */
      ipadr    = 0  ;
      rem_port = 0  ;
      ownipadr = 0  ;
      own_port = 0  ;
      socket   = -1 ;
      ret_val  = TOFIXED('8001'B4) ;
    FIN ;
  ELSE
    /* keine Verbindung */
    ipadr    = 0  ;
    rem_port = 0  ;
    ownipadr = 0  ;
    own_port = 0  ;
    socket   = -1 ;
    ret_val  = TOFIXED('8002'B4) ;
  FIN ;

  RETURN( ret_val );

END ; /* PROC NET_OPEN ------------------------------------------------------*/
